/****************************************************/
/*             SWAPPERTEST Version 1.0              */
/* entwickelt von Jens Lauschke , Berlin - April'95 */
/****************************************************/

CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
SysLoadFuncs()
CALL RxFuncAdd "VInit", "VREXX", "VINIT"
initcode = VInit()
IF initcode = "ERROR" THEN signal BEENDEN

signal on failure name BEENDEN
signal on halt name BEENDEN
signal on syntax name BEENDEN

PROGRAMM:
        CALL VDialogPos 50 , 50
        nachricht.0 = 8
        nachricht.1 = "    SWAPPERTEST Version 1.0 erstellt von Jens Lauschke"
        nachricht.2 = "                                   Berlin-April'95"
        nachricht.3 = " "
        nachricht.4 = "    Die Auslagerungsdatei hat eine Gre von"
        nachricht.5 = " "
        nachricht.6 = "    Wollen Sie, da dieses Programm im Hintergrund die Gre"
        nachricht.7 = "    der Datei, ber einem von Ihnen festzulegenden Zeitraum,"
        nachricht.8 = "    testet und danach grafisch darstellt ?"
        laufwerke = SysDriveMap(,"USED")
        DO i = 1 TO WORDS(laufwerke)
                rueckgabewert = SysFileSearch("SWAPPATH",WORD(laufwerke,i)"\CONFIG.SYS",sw)
                IF rueckgabewert = 0 THEN LEAVE
        END /*DO*/
        laufwerk = WORD(laufwerke,i)
        IF rueckgabewert <> 0 THEN DO
                SAY "Datei config.sys auf keinem der benutzten Laufwerke gefunden !!!"
                SAY "Stabilittstest ???"
                SAY "Programm beendet ..."
                CALL BEENDEN
        END /*IF-DO*/
        rueckgabewert = SysFileSearch("MEMMAN",laufwerk"\CONFIG.SYS",benutzung)
        IF POS("NOSWAP",benutzung.1) <> 0 THEN DO
                SAY "Es wird keine Auslagerungsdatei benutzt !"
                SAY "Programm beendet"
                CALL BEENDEN
        END /*IF-DO*/
        dlage = WORD(SUBSTR(sw.1,10),1)"\SWAPPER.DAT"
        danfang = WORD(SUBSTR(sw.1,10),3) ; dfdfrei = WORD(SUBSTR(sw.1,10),2)
        IF TRUNC(danfang/1024,0) <> danfang/1024 THEN danfang = 1024 * (TRUNC(danfang/1024,0)+1)
        rueckgabewert = SysFileTree(dlage, datei, F)
        nachricht.4 = nachricht.4 WORD(datei.1,3)/1024 "KB."
        swapper = WORD(datei.1,3)/1024 ; swappermax = swapper
        liste.0 = 0
        rueckgabewert1 = VMsgBox("SWAPPERTEST --->FREEWARE<---",nachricht,6)
        IF rueckgabewert1 = "NO" THEN CALL ABBRUCH
        ELSE DO
                text.0 = 6
                text.1 = "  5 Minuten"
                text.2 = " 10 Minuten"
                text.3 = " 20 Minuten"
                text.4 = " 30 Minuten"
                text.5 = " 45 Minuten"
                text.6 = " 60 Minuten (empfohlen)"
                CALL VRadioBox "Dauer des Tests ?",text,1
                zeit = WORD(text.vstring,1) * 60
                CALL TESTSCHLEIFE
                CALL LISTE
        END /*ELSE-DO*/
        CALL BEENDEN
RETURN  /* wird nie erreicht ... */

TESTSCHLEIFE:
        info.LEFT = 0
        info.BOTTOM = 90
        info.TOP = 100
        info.RIGHT = 30
        infofenster = VOpenWindow("Infofenster",WHITE,info)
        zeitschleife = zeit / 5
        DO durchlauf = 1 TO zeitschleife
                CALL VClearWindow(infofenster)
                jetztmin = ( durchlauf * 5 ) / 60
                zeitdiff = ( zeit - ( durchlauf * 5 )) / 60
                zeit1 = SPACE(TRUNC(jetztmin,0)":"FORMAT((jetztmin-TRUNC(jetztmin,0))*60,2,0),1,0)
                zeit2 = SPACE(TRUNC(zeitdiff,0)":"FORMAT((zeitdiff-TRUNC(zeitdiff,0))*60,2,0),1,0)
                CALL VSay infofenster , 50 , 750 , "verstrichene Zeit : " zeit1 " Minuten"
                CALL VSay infofenster , 50 , 550 , "verbleibende Zeit : " zeit2 " Minuten"
                rueckgabewert = SysFileTree(dlage, datei, F)
                test_swapper = WORD(datei.1,3)/1024
                CALL VSay infofenster , 50 , 350 , "derzeitige Gre  : " test_swapper "KB"
                liste.0 =liste.0 + 1 ; merker = liste.0
                liste.merker = WORD(datei.1,3) / 1024 / 1024
                IF test_swapper > swappermax THEN swappermax = test_swapper
                CALL VSay infofenster , 50 , 150 , "maximale Gre    : " swappermax "KB"
                CALL SysSleep(5)
        END /*DO*/
        CALL VCloseWindow(infofenster)
        CALL ZEITENDE
RETURN

ZEITENDE:
        text.0 = 9
        text.1 = " Das Programm SWAPPER.DAT-Kontrolle wird bendet,"
        text.2 = " da das Zeitlimit von " zeit / 60 "Minuten erreicht"
        text.3 = " wurde . Empfehlungen fr die Einstellung der Start-"
        text.4 = " gre der SWAPPER.DAT : "
        text.5 = " "
        text.8 = " "
        text.9 = " Es folgt die grafische Darstellung (OK) ..."
        SELECT
                WHEN swappermax > danfang THEN DO
                        text.6 = " Die Startgre sollte in der CONFIG.SYS auf "
                        text.7 = swappermax " KB eingestellt werden ( Empfehlung ) !"
                END /*WHEN-END*/
                WHEN swappermax = danfang THEN DO
                        IF danfang <= 32768 THEN DO
                                text.6 = " Die Startgre ist in der CONFIG.SYS hchstwahr-"
                                text.7 = " scheinlich optimal eingestellt (" danfang " KB) !"
                        END /*IF-DO*/
                        ELSE DO
                                text.5 = " Die Startgre ist in der CONFIG.SYS zu hoch ein-"
                                text.6 = " gestellt ( ber 32 MB ) ! Empfehle die Startgre"
                                text.7 = " zu halbieren - Systemabschlu durchfhren ; System"
                                text.8 = " und SWAPPERTEST neu starten ..."
                        END /*ELSE-DO*/
                END /*WHEN-DO*/
        END /*SELECT*/
        rueckgabewert = VMsgBox( "Zeitende" , text , 1)
RETURN

ABBRUCH:
        text.0 = 5
        text.1 = " Lage :" dlage
        text.2 = " Volumen der SWAPPER.DAT :" WORD(datei.1,3)/1024 "KB ."
        text.3 = " Minimal freie Festplattenkapazitt :" dfdfrei "KB ."
        text.4 = " Die Startgre betrgt" danfang "KB ."
        text.5 = " Es werden zustzlich" (WORD(datei.1,3)/1024)-danfang "KB benutzt !"
        rueckgabewert = VMsgBox("SWAPPERTEST",text,1)
RETURN

LISTE:
        pos.LEFT = 0
        pos.BOTTOM = 0
        pos.RIGHT = 100
        pos.TOP = 100
        grafikfenster = VOpenWindow("Zeit- Grengrafik","BLUE",pos)
        CALL VForeColor grafikfenster , "WHITE"
        x_wert.1 = 100 ; x_wert.2 = 100
        y_wert.1 = 50  ; y_wert.2 = 900
        CALL VDraw grafikfenster , LINE , x_wert , y_wert , 2
        x_wert.1 = 50  ; x_wert.2 = 900
        y_wert.1 = 100 ; y_wert.2 = 100
        CALL VDraw grafikfenster , LINE , x_wert , y_wert , 2
        x = 800 ; y = 20
        CALL VSay grafikfenster , x , y , "Minuten"
        x = 20  ; y = 940
        CALL VSay grafikfenster , x , y , "KByte"
        x = 20  ; y = 80  ; t = 2048
        DO i = 1 TO 16
                CALL VSay grafikfenster , x , y + ( i * 50 ) , t * i
        END
        x = 100  ; y = 50
        DO i = 5 TO 60 BY 5
                CALL VSay grafikfenster , x + ( i * 12 ) , y , i
        END
        x_max.1 = 100 ; x_max.2 = 100 + ( zeit / 5 )
        y_max.1 = 85 + ( swappermax / 1024 * 25 ) ; y_max.2 = y_max.1
        CALL VForeColor grafikfenster , RED
        CALL VDraw grafikfenster , LINE , x_max , y_max , 2
        CALL VSay grafikfenster , x_max.2 + 2 , y_max.2 - 4 , "max"
        x_min.1 = 100 ; x_min.2 = 100 + ( zeit / 5 )
        y_min.1 = 85 + ( danfang / 1024 * 25 ) ; y_min.2 = y_min.1
        CALL VForeColor grafikfenster , GREEN
        CALL VDraw grafikfenster , LINE , x_min , y_min , 2
        CALL VSay grafikfenster , x_min.2 + 2 , y_min.2 - 4 , "min"
        CALL VForeColor grafikfenster , YELLOW
        DO i = 2 TO liste.0
                j = i - 1
                x_pos.1 = 100 + j ; x_pos.2 = 100 + i
                y_pos.1 = 85 + ( liste.j * 25 ) ; y_pos.2 = 85 + ( liste.i * 25 )
                CALL VDraw grafikfenster , LINE, x_pos, y_pos, 2
        END
        text.0 = 7
        text.1 = " Lage :" dlage
        text.2 = " derzeitiges Volumen der SWAPPER.DAT :" WORD(datei.1,3)/1024 "KB ."
        text.3 = " Minimal freie Festplattenkapazitt :" dfdfrei "KB ."
        text.4 = " Die Startgre betrgt" danfang "KB ."
        text.5 = " Es werden zustzlich" (WORD(datei.1,3)/1024)-danfang "KB benutzt !"
        text.6 = " "
        text.7 = " festgestellte Maximalgre :" swappermax " KB"
        rueckgabewert = VMsgBox("SWAPPER.DAT",text,1)
        CALL VDialogPos 100 , 100
        CALL VCloseWindow(grafikfenster)
RETURN

BEENDEN:
     CALL VExit
EXIT
