/* PGPREXX.CMD
   to build a user-friendly interface
   to the Pretty-Good-Privacy program */

'@echo off'
/* trace all */
call RxFuncAdd 'VInit', 'VREXX', 'VINIT'
initcode = VInit()
if initcode = 'ERROR' then do
signal CLEANUP1
end

signal on failure name CLEANUP2
signal on halt name CLEANUP3
/*signal on syntax name CLEANUP4 */

cls
curdir = directory()
env = 'OS2ENVIRONMENT'
pathname = value('PGPPATH',,env)
if pathname = '' then do
  say '"'PGPPATH'" is not in the environment!'
  say 'PGP will not work...'
  signal CLEANUP2
end
waitmsg = 'Building the key-table. Wait a moment...'

msg.0 = 9
msg.1 = ' '
msg.2 = '  Version 1.4 '
msg.3 = '  04.04.1995 '
msg.4 = '  Reinhard Schck'
msg.5 = '  '
msg.6 = '  PGP-Path: '
msg.7 = '  '||pathname
msg.8 = '  Public Ring: '
msg.9 = '  '||pathname||'PUBRING.PGP'
call VDialogPos 50, 50
call VMsgBox 'PGP-OS/2-Front-End', msg, 1

act.0 = 5
act.1 = ' Edit a Message'
act.2 = ' Encrypt/Sign'
act.3 = ' Decrypt'
act.4 = ' IDEA-Encryption'
act.5 = ' Key Management'

keym.0 = 7
keym.1 = ' View Keys'
keym.2 = ' Extract Key to File'
keym.3 = ' Add Key to Ring'
keym.4 = ' Remove Key/Signature'
keym.5 = ' Check Keys/UserId'
keym.6 = ' Generate Keys'
keym.7 = ' Display Key-Table'

call ringlist

LOOP:
cls
list.0 = act.0
list.1 = act.1
list.2 = act.2
list.3 = act.3
list.4 = act.4
list.5 = act.5

rb = VRadioBox('Select Action', list, 3)
if rb = 'OK' then do
  selnum = list.vstring
  select
    when selnum = act.1 then call EDIT
    when selnum = act.2 then call ENCRYPT
    when selnum = act.3 then call DECRYPT
    when selnum = act.4 then call IDEA
    when selnum = act.5 then call KEYS
    otherwise
      say "Error in selection"
  end /* select */
  signal LOOP
end /* end rb OK */
else signal CLEANUP

VRING:
    say waitmsg
    rb = VTableBox(pubtitle, pubtab, 1, 80, 15, 1)
    cls
return

EDIT:
rb = VFileBox('Select a file...', '*.*', file)
if rb = 'OK' then do
  filename = file.vstring
  t2 filename
end /* end rb OK */
return

ENCRYPT:
list.0 = 6
list.1 = ' Encryption'
list.2 = ' Include Signature'
list.3 = ' ASCII armor'
list.4 = ' Text input'
list.5 = ' For her eyes only'
list.6 = ' Wipe file'
sel.0 = 4
sel.1 = list.1
sel.2 = list.2
sel.3 = list.3
sel.4 = list.4
enc = '';sig = ''; asc = ''; txt = ''; eyes = ''; wip = '';

rb = VCheckbox(' Specify Encryption...', list, sel, 3)
if rb = 'OK' then
  DO i=1 to sel.0
    if sel.i = list.1 then enc = e
    if sel.i = list.2 then sig = s
    if sel.i = list.3 then asc = a
    if sel.i = list.4 then txt = t
    if sel.i = list.5 then eyes = m
    if sel.i = list.6 then wip = w
  end /* end rb OK */
else return

if enc = e then do
  sel.0 = 2
  sel.1 = 'Select Name from Ring'
  sel.2 = 'Enter UserID         '
  call VRadioBox 'Define Recipient...', sel, 1
  if sel.vstring = sel.1 then do
    say waitmsg
    rb = VTableBox(pubtitle, pubtab, 1, 80, 15, 1)
    selnum = pubtab.vstring
    name = pubtab.selnum.4
  end /* end sel1 */
  if sel.vstring = sel.2 then do
    prompt.0 = 3
    prompt.1 = ' '
    prompt.2 = ' Enter recipient:'
    prompt.3 = ' '
    rb = VInputBox("Recipient's name", prompt, 20, 3)
    if rb = 'OK' then
      name = prompt.vstring
  end /* end sel2 */
  end /* end enc=e */
else name = ''

  param = "-"||enc||sig||asc||txt||eyes||wip
  rb = VFileBox('Select a File for Encryption...', '*.*', file)
  if rb = 'OK' then do
    filename = file.vstring
    comm.0 = 1
    comm.1 = ' Generated Command is:    '
    if enc = e then
      comm.vstring = pgp param filename '"'name'"'
    else
      comm.vstring = pgp param filename
    rb1 = VInputBox(" Edit Command: ", comm, 60, 3)
    if rb1 = 'OK' then comm.vstring
    else return
  end /* end rb OK */
  pause
return

IDEA:
rb = VFileBox('Select a File for IDEA-encryption...', '*.*', file)
if rb = 'OK' then do
  filename = file.vstring
  comm.0 = 1
  comm.1 = ' Generated Command is:    '
  comm.vstring = pgp '-c' filename
  rb1 = VInputBox(" Edit Command: ", comm, 60, 3)
  if rb1 = 'OK' then comm.vstring
  else return
end /* end rb OK */
pause
return

DECRYPT:
rb = VFileBox('Select a File for Decryption...', '*.*', file)
if rb = 'OK' then do
  filename = file.vstring
  comm.0 = 1
  comm.1 = ' Generated Command is:    '
  comm.vstring = pgp filename
  rb1 = VInputBox(" Edit Command: ", comm, 60, 3)
  if rb1 = 'OK' then comm.vstring
  else return
end /* end rb OK */
pause
return

KEYS:
cls
list.0 = keym.0
list.1 = keym.1
list.2 = keym.2
list.3 = keym.3
list.4 = keym.4
list.5 = keym.5
list.6 = keym.6
list.7 = keym.7

rb = VRadioBox('Select Action for Keys...', list, 3)
if rb = 'OK' then do

  action = list.vstring

  select
  when action = keym.1 then do

    klist.0 = 2
    klist.1 = ' View Signatures'
    klist.2 = ' View Fingerprint'

    sel.0 = klist.0
    sel.1 = ''
    sel.2 = ''

    vsig = ''; vfin = '';

    rb = VCheckbox(' Specify View... ', klist, sel, 3)
    if rb = 'OK' then
    DO i=1 to sel.0
      if sel.i = klist.1 then vsig = v
      if sel.i = klist.2 then vfin = c
    end /* end rb OK */
    else signal KEYS

    prompt.0 = 3
    prompt.1 = 'UserID  '
    prompt.2 = 'PGP-Path'
    prompt.3 = 'Keyring'

    width.0 = prompt.0
    width.1 = 20; width.2 = 15; width.3 = 15;

    hide.0 = prompt.0
    hide.1 = 0; hide.2 = 0; hide.3 = 0;

    answer.0 = prompt.0
    answer.1 = ''
    answer.2 = pathname
    answer.3 = 'PUBRING.PGP'

    rb = VMultBox('  View Keys/Signatures...', prompt, width, hide, answer, 3)
    if rb = 'OK' then do
      user = answer.1
      newpath = answer.2
      ring = answer.3
      param = '-KV'||vsig||vfin
      comm.0 = 1
      comm.1 = ' Generated Command is:    '
      comm.vstring = pgp param '"'user'"' newpath||ring
      rb1 = VInputBox(" Edit Command: ", comm, 60, 3)
      if rb1 = 'OK' then comm.vstring
      else signal KEYS
      pause
    end /* end rb OK */
  end /* end when do */

  when action = keym.2 then do            /* Extract Key to File */

    sel.0 = 2
    sel.1 = 'Select Name from Ring'
    sel.2 = 'Enter UserID         '
    call VRadioBox 'Define UserID...', sel, 1

    if sel.vstring = sel.1 then do
      say waitmsg
      rb = VTableBox(pubtitle, pubtab, 1, 80, 15, 1)
      selnum = pubtab.vstring
      name = pubtab.selnum.4
      cls
    end /* end sel1 */
    if sel.vstring = sel.2 then do
      prompt.0 = 3
      prompt.1 = ' '
      prompt.2 = ' Enter recipient:'
      prompt.3 = ' '
      rb = VInputBox('UserID...', prompt, 20, 1)
      name = prompt.vstring
    end /* end sel2 */

    klist.0 = 2
    klist.1 = ' To ASCII-File'
    klist.2 = ' To PGP-File'
    rb = VRadioBox(' Specify Extract... ', klist, 3)
    if rb = 'OK' then do
      if klist.vstring = klist.1 then asc = a
      if klist.vstring = klist.2 then asc = ''
    end /* end rb OK */
    else signal KEYS

     prompt.0 = 3
     prompt.1 = 'UserID  '
     prompt.2 = 'PGP-Path'
     prompt.3 = 'Keyring '

     width.0 = prompt.0
     width.1 = 20; width.2 = 12; width.3 = 15;

     hide.0 = prompt.0
     hide.1 = 0; hide.2 = 0;  hide.3 = 0;

     answer.0 = prompt.0
     answer.1 = name
     answer.2 = pathname
     answer.3 = 'PUBRING.PGP'

     rb = VMultBox('  Extract Key to File...', prompt, width, hide, answer, 3)
     if rb = 'OK' then do
        user = answer.1
        newpath = answer.2
        ring = answer.3
        parse var name keyfile rest
        if length(keyfile) > 8 then keyfile = substr(keyfile,1,8)
        param = '-KX'||asc
        comm.0 = 1
        comm.1 = ' Generated Command is:    '
        comm.vstring = pgp param '"'user'"' keyfile newpath||ring
        rb1 = VInputBox(" Edit Command: ", comm, 60, 3)
        if rb1 = 'OK' then comm.vstring
        else signal KEYS
        pause
     end /* end rb OK */
  end /* when do */

  when (action = keym.3) then do              /* Add Key to Ring */

     rb = VFileBox('Select a keyfile...', '*.*', file)
     if rb = 'OK' then do
       filename = file.vstring

       prompt.0 = 3
       prompt.1 = 'Keyfile '
       prompt.2 = 'PGP-Path'
       prompt.3 = 'Keyring'

       width.0 = prompt.0
       width.1 = 30; width.2 = 15; width.3 = 15

       hide.0 = prompt.0
       hide.1 = 0; hide.2 = 0; hide.3 = 0;

       answer.0 = prompt.0
       answer.1 = filename
       answer.2 = pathname
       answer.3 = 'PUBRING.PGP'

       rb1 = VMultBox('  Add Key to Ring...', prompt, width, hide, answer, 3)
       if rb1 = 'OK' then do
         keyfile = answer.1
         newpath = answer.2
         ring = answer.3
         comm.0 = 1
         comm.1 = ' Generated Command is:     '
         comm.vstring = pgp '-ka' keyfile newpath||ring
         rb2 = VInputBox(" Edit Command: ", comm, 60, 3)
         if rb2 = 'OK' then do
           comm.vstring
           call ringlist
         end
         else signal KEYS
         pause
       end /* end rb1 OK */
     end /* end rb OK */
     else signal KEYS
  end /* when do */

  when (action = keym.4) then do              /* Remove Key/Signature/UserID */

    klist.0 = 1
    klist.1 = ' Signature only'
    sel.0 = klist.0
    sel.1 = ''
    rsig = '';
    rb = VCheckbox(' Specify Remove... ', klist, sel, 3)
    if rb = 'OK' then do
      if sel.1 = klist.1 then rsig = s
    end /* end rb OK */
    else signal KEYS

    say waitmsg
    rb = VTableBox(pubtitle, pubtab, 1, 80, 15, 1)
    selnum = pubtab.vstring
    name = pubtab.selnum.4

    prompt.0 = 3
    prompt.1 = 'UserID  '
    prompt.2 = 'PGP-Path'
    prompt.3 = 'Keyring'

    width.0 = prompt.0
    width.1 = 25; width.2 = 15; width.3 = 15

    hide.0 = prompt.0
    hide.1 = 0; hide.2 = 0; hide.3 = 0;

    answer.0 = prompt.0
    answer.1 = name
    answer.2 = pathname
    answer.3 = 'PUBRING.PGP'

    rb = VMultBox('  Remove Key/Signature/Userid...', prompt, width, hide, answer, 3)
    if rb = 'OK' then do
      user = answer.1
      newpath = answer.2
      ring = answer.3
      param = '-KR'||rsig
      comm.0 = 1
      comm.1 = ' Generated Command is:    '
      comm.vstring = pgp param '"'user'"' newpath||ring
      rb1 = VInputBox(" Edit Command: ", comm, 60, 3)
      if rb1 = 'OK' then do
        comm.vstring
        if rsig='' then call ringlist
      end /* end rb1 OK */
      else signal KEYS
      pause
    end /* end rb OK */
    signal KEYS
  end /* end when do */

  when action = keym.5 then do                  /* Check Keys     */
     param = '-KC'
     comm.0 = 1
     comm.1 = ' Generated Command is:    '
     comm.vstring = pgp param
     rb1 = VInputBox(" Edit Command: ", comm, 60, 3)
     if rb1 = 'OK' then
       comm.vstring
     pause
     signal KEYS
  end /* end when do */

  when action = keym.6 then do                  /* Key Generation */
     param = '-KG'
     comm.0 = 1
     comm.1 = ' Generated Command is:    '
     comm.vstring = pgp param
     rb1 = VInputBox(" Edit Command: ", comm, 60, 3)
     if rb1 = 'OK' then
       comm.vstring
     pause
     signal KEYS
  end /* end when do */

  when action = keym.7 then do                 /* Display Key-table */
     say waitmsg
     call VTableBox pubtitle, pubtab, 1, 80, 15, 1
     cls
     signal KEYS
  end /* end when do */

  otherwise signal KEYS
end /* select */
end /* enddo */
else return
return

RINGLIST:
/* prepare keyring-file */
pgp '-kv *' pathname||'pubring.pgp >' curdir||'\pubring.lst'
curring = curdir || '\pubring.lst'
pubtitle = linein(curring, 1, 1)    /* read first empty line */
pubtitle = linein(curring)          /* read title line */
pubtab.rows = 80
pubtab.cols = 4
header = linein(curring)         /* read header line */
parse var header h1 h2 h3 h4

pubtab.label.1 = h1
pubtab.label.2 = h2
pubtab.label.3 = h3
pubtab.label.4 = h4

pubtab.width.1 = 5
pubtab.width.2 = 14
pubtab.width.3 = 11
pubtab.width.4 = 50

i = 1
do while (lines(curring) > 0)
  curline=linein(curring)
  if substr(curline,1,1) = ' ' then x = value('curline','* * * '||curline)
  parse var curline type keyid crdate name
  name = strip(name,'L')
  if type = '*' then type = ' '
  if keyid = '*' then keyid = ' '
  if crdate = '*' then crdate = ' '
  pubtab.i.1 = type
  pubtab.i.2 = keyid
  pubtab.i.3 = crdate
  pubtab.i.4 = name
  i = i + 1
end
cls
fmsg = stream(curring,'c','close')
return

CLEANUP1:
  say ERROR loading VINIT detected
CLEANUP2:
  say FAILURE detected
CLEANUP3:
  say HALT detected
CLEANUP4:
  say SYNTAX error detected
CLEANUP:
  say "THAT'S THE END"
  call VExit
exit

